Rem Utility to edit bookmarks history list in QB64.

Rem $dynamic

DefInt A-Z

Dim Shared RecentList(1) As String

ReDim RecentList(1024) As String

File$ = "c:\qb64pe\internal\temp\bookmarks.bin"
Close
If _FileExists(File$) = 0 Then
    Open File$ For Output As #1
    Print #1, ""
    Print #1, ""
    Print #1, Chr$(0) + Chr$(0) + Chr$(0) + Chr$(0)
    Print #1, ""
    Print "Bookmarks.bin init."
End If
Close
Open File$ For Input As #1
Line Input #1, Line$
Do
    If EOF(1) Then Exit Do
    Line Input #1, Line1$

    If EOF(1) Then Exit Do
    Line Input #1, Line2$

    LineNum = LineNum + 1
    RecentList(LineNum) = Line1$
Loop

Color 15
Print "Bookmarks.bin loaded."

Do
    Color 15
    Print "Bookmarks editor"
    Color 14
    Print "(A)dd to list"
    Print "(C)lear list"
    Print "(E)dit value"
    Print "(L)ist values"
    Print "(R)emove value"
    Print "(S)ort list"
    Print "(U)pload list"
    Print "(W)rite list"
    Print "(Q)uit and save"
    Color 15
    Print "Enter option?";
    Do
        _Limit 100
        Inp$ = InKey$
        If Len(Inp$) Then
            Inp$ = UCase$(Inp$)
            Select Case Inp$
                Case "A"
                    Print "A"
                    Print "Enter bookmark to add:"
                    Print "?";
                    Line Input Line$
                    If Len(Line$) Then
                        LineNum = LineNum + 1
                        RecentList(LineNum) = Line$
                        Print "Value added."
                    Else
                        Print "Value not found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "C"
                    Print "C"
                    LineNum = 0
                    Print "List cleared."
                    Call MorePrompt
                    Exit Do
                Case "L"
                    Print "L"
                    Found = 0
                    LineX = 0
                    For Linen = 1 To LineNum
                        Count$ = LTrim$(Str$(Linen))
                        Print "("; Count$; ")"; RecentList(Linen)
                        Found = -1
                        LineX = LineX + 1
                        If LineX >= 23 Then
                            LineX = 0
                            Call MorePrompt
                        End If
                    Next
                    If Found = 0 Then
                        Print "No values found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "E"
                    Print "E"
                    If LineNum > 0 Then
                        Count$ = LTrim$(Str$(Linen))
                        Print "Enter line to edit(1-"; Count$; ")";
                        Input Linen
                        If Linen > 0 And Linen <= LineNum Then
                            Print "Enter bookmark:"
                            Print "?";
                            Line Input Line$
                            If Len(Line$) Then
                                RecentList(Linen) = Line$
                                Print "Value edited."
                            Else
                                Print "Bookmark not found."
                            End If
                        Else
                            Print "Value not found."
                        End If
                    Else
                        Print "No values found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "R"
                    Print "R"
                    If LineNum > 0 Then
                        Count$ = LTrim$(Str$(LineNum))
                        Print "Enter line to remove(1-"; Count$; ")";
                        Input Linen
                        If Linen > 0 And Linen <= LineNum Then
                            For LineX = Linen To LineNum - 1
                                RecentList(LineX) = RecentList(LineX + 1)
                            Next
                            LineNum = LineNum - 1
                            Print "Value removed."
                        Else
                            Print "Value not found."
                        End If
                    Else
                        Print "No values found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "S"
                    Print "S"
                    For Sort1 = 1 To LineNum
                        For Sort2 = Sort1 + 1 To LineNum
                            If RecentList(Sort1) > RecentList(Sort2) Then
                                Swap RecentList(Sort1), RecentList(Sort2)
                            End If
                        Next
                    Next
                    Print "List Sorted."
                    Call MorePrompt
                    Exit Do
                Case "U"
                    Print "U"
                    LineNum = 0
                    Close
                    Open File$ For Input As #1
                    Line Input #1, Line$
                    Do
                        If EOF(1) Then Exit Do
                        Line Input #1, Line1$

                        If EOF(1) Then Exit Do
                        Line Input #1, Line2$

                        LineNum = LineNum + 1
                        RecentList(LineNum) = Line1$
                    Loop
                    Print "List reloaded."
                    Call MorePrompt
                    Exit Do
                Case "W"
                    Print "W"
                    Close
                    Open File$ For Output As #1
                    Print #1, ""
                    For Linen = 1 To LineNum
                        Print #1, RecentList(Linen)
                        Print #1, Chr$(0) + Chr$(0) + Chr$(0) + Chr$(0)
                    Next
                    Print #1, ""
                    Print "Bookmarks.bin written."
                    Call MorePrompt
                    Exit Do
                Case "Q"
                    Print "Q"
                    Print "Write bookmarks.bin(y/n)? ";
                    Do
                        _Limit 100
                        Write$ = InKey$
                        If Len(Write$) Then
                            Print
                            Write$ = UCase$(Write$)
                            Exit Do
                        End If
                    Loop
                    If Write$ = "Y" Then
                        If LineNum = 0 Then
                            Print "No values written."
                        Else
                            Close
                            Open File$ For Output As #1
                            Print #1, ""
                            For Linen = 1 To LineNum
                                Print #1, RecentList(Linen)
                                Print #1, Chr$(0) + Chr$(0) + Chr$(0) + Chr$(0)
                            Next
                            Print #1, ""
                            Print "Bookmarks.bin written."
                        End If
                    End If
                    Call MorePrompt
                    Color 7
                    End
            End Select
        End If
    Loop
Loop
End

Sub MorePrompt
    Print "-more-";
    Do
        _Limit 100
        X$ = InKey$
        If Len(X$) Then
            Exit Do
        End If
    Loop
    Print
End Sub

