Rem Utility to edit recent history list in QB64.

Rem $dynamic

DefInt A-Z

Dim Shared RecentList(1) As String

ReDim RecentList(1024) As String

File$ = "c:\qb64pe\internal\temp\searched.bin"
Close
If _FileExists(File$) = 0 Then
    Open File$ For Output As #1
    Print #1, ""
    Print "Searched.bin init."
End If
Close
Open File$ For Input As #1
Do
    If EOF(1) Then Exit Do
    Line Input #1, Line$
    LineNum = LineNum + 1
    RecentList(LineNum) = Line$
Loop

Color 15
Print "Searched.bin loaded."

Do
    Color 15
    Print "Searched editor"
    Color 14
    Print "(A)dd to list"
    Print "(C)lear list"
    Print "(E)dit text"
    Print "(L)ist text"
    Print "(R)emove text"
    Print "(U)pload list"
    Print "(W)rite list"
    Print "(Q)uit and save"
    Color 15
    Print "Enter option?";
    Do
        _Limit 100
        Inp$ = InKey$
        If Len(Inp$) Then
            Inp$ = UCase$(Inp$)
            Select Case Inp$
                Case "A"
                    Print "A"
                    Print "Enter text to add:"
                    Print "?";
                    Line Input Line$
                    If Len(Line$) Then
                        LineNum = LineNum + 1
                        RecentList(LineNum) = Line$
                        Print "Text added."
                    Else
                        Print "Text not found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "C"
                    Print "C"
                    LineNum = 0
                    Print "List cleared."
                    Call MorePrompt
                    Exit Do
                Case "L"
                    Print "L"
                    Found = 0
                    LineX = 0
                    For Linen = 1 To LineNum
                        Count$ = LTrim$(Str$(Linen))
                        Print "("; Count$; ")"; RecentList(Linen)
                        Found = -1
                        LineX = LineX + 1
                        If LineX >= 23 Then
                            LineX = 0
                            Call MorePrompt
                        End If
                    Next
                    If Found = 0 Then
                        Print "No text found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "E"
                    Print "E"
                    If LineNum > 0 Then
                        Count$ = LTrim$(Str$(Linen))
                        Print "Enter line to edit(1-"; Count$; ")";
                        Input Linen
                        If Linen > 0 And Linen <= LineNum Then
                            Print "Enter text:"
                            Print "?";
                            Line Input Line$
                            If Len(Line$) Then
                                RecentList(Linen) = Line$
                                Print "Text edited."
                            Else
                                Print "Text not found."
                            End If
                        Else
                            Print "Text not found."
                        End If
                    Else
                        Print "No text found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "R"
                    Print "R"
                    If LineNum > 0 Then
                        Count$ = LTrim$(Str$(LineNum))
                        Print "Enter line to remove(1-"; Count$; ")";
                        Input Linen
                        If Linen > 0 And Linen <= LineNum Then
                            For LineX = Linen To LineNum - 1
                                RecentList(LineX) = RecentList(LineX + 1)
                            Next
                            LineNum = LineNum - 1
                            Print "Text removed."
                        Else
                            Print "Text not found."
                        End If
                    Else
                        Print "No text found."
                    End If
                    Call MorePrompt
                    Exit Do
                Case "U"
                    Print "U"
                    LineNum = 0
                    Close
                    Open File$ For Input As #1
                    Do
                        If EOF(1) Then Exit Do
                        Line Input #1, Line$
                        LineNum = LineNum + 1
                        RecentList(LineNum) = Line$
                    Loop
                    Print "List reloaded."
                    Call MorePrompt
                    Exit Do
                Case "W"
                    Print "W"
                    Close
                    Open File$ For Output As #1
                    For Linen = 1 To LineNum
                        Print #1, RecentList(Linen)
                    Next
                    Print "Searched.bin written."
                    Call MorePrompt
                    Exit Do
                Case "Q"
                    Print "Q"
                    Print "Write searched.bin(y/n)? ";
                    Do
                        _Limit 100
                        Write$ = InKey$
                        If Len(Write$) Then
                            Print
                            Write$ = UCase$(Write$)
                            Exit Do
                        End If
                    Loop
                    If Write$ = "Y" Then
                        If LineNum = 0 Then
                            Print "No text written."
                        Else
                            Close
                            Open File$ For Output As #1
                            For Linen = 1 To LineNum
                                Print #1, RecentList(Linen)
                            Next
                            Print "Searched.bin written."
                        End If
                    End If
                    Call MorePrompt
                    Color 7
                    End
            End Select
        End If
    Loop
Loop
End

Sub MorePrompt
    Print "-more-";
    Do
        _Limit 100
        X$ = InKey$
        If Len(X$) Then
            Exit Do
        End If
    Loop
    Print
End Sub

